/*

	Sphelar Solar Cells Accessory

	ATtiny13A

	Copyrights 2010,  Yoshi Hiroshi.

    FUSE Settings:  HIGH:0xFF  LOW:0x33
        CLOCK: 128KHz, 14CK + 0 ms
        EESAVE: ON
        CKDIV8: OFF

 */

#define NUM_PATTARN            6

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <util/delay.h>

/*
        EEPROM̐ݒ

        EEPROMAݒ擾
        EEPROMցAݒL^
 */
void getConfByte();
void setConfigByte();

/*
        

        WDT(16mS)ɁA
        肷B
 */
volatile unsigned char interruptCount;
volatile unsigned char intervalCount;
volatile unsigned int  startupTimer;

/*
        샂[h

@      RtBM[Ve[u
        샂[hɉp[^擾
 */
volatile unsigned char configByte;      // ݂̓샂[h
volatile char dischargeClock;           // d̓NbN
volatile char boostCount;               // ̏pX
unsigned char configSave EEMEM;         // Ō̓샂[h(EEPROM)

/*
        o̓p^[
 */
unsigned char* pattern;
unsigned char patSize;
volatile unsigned char patCount;
unsigned char* patPtr;
unsigned char patData;

unsigned char patternF[] EEMEM = 
{
    0x18, 0x42
};

unsigned char pattern1[] EEMEM = 
{
    0xF4
};
unsigned char pattern2[] EEMEM = 
{
    0x96, 0x00, 0x00, 0x00
};

unsigned char pattern3[] EEMEM = 
{
    0x12, 0x48, 0x00, 0x10, 
    0x00, 0x00, 0x00, 0x00, 
    0x40, 0x00, 0x00, 0x00, 
    0x80, 0x00, 0x00, 0x00, 
    0x10, 0x00, 0x20, 0x00
};

/*
        샂[h̒`
 */
struct configType_ {                    // 샂[h̃e[u(EEPROM)
    unsigned char boostCount;
    unsigned char dischargeClock;
    unsigned char intervalCount;
    unsigned char pattarnNum;
    unsigned char pattarnLen;
} confDefs[] EEMEM =
{
    { 1, 1,  64, 5, 4  },
    { 1, 2, 128, 1, 2  },
    { 6, 2,  16, 2, 8  },
    { 1, 4,   6, 3, 40 },
    { 8, 6,   2, 3, 40 },
    {12, 6,   6, 5, 4  }
};

//================================================
void wdtEnable()
{
    MCUSR &= ~_BV(WDRF);
    WDTCR |= _BV(WDCE) | _BV(WDE);
    WDTCR = _BV(WDTIE);                 // 16mS;
}

//================================================
void clockFast()
{
    CLKPR = _BV(CLKPCE);
    CLKPR = 0;          // 128KHz
}

//================================================
void clockSlow(char div)
{
    CLKPR = _BV(CLKPCE);
    CLKPR = div;          // 32KHz
}

//================================================
ISR(WDT_vect)
{
}

//================================================
void flashLED()
{
    unsigned char work;
    if(patCount & 0x01) {
        patPtr++;
        work = patData & 0x0F;
    } else {
        patData = eeprom_read_byte(patPtr);
        work = patData >> 4;
    }
    clockSlow(dischargeClock);
    PORTB = work;
    PORTB = 0;
    clockFast();
    patCount++;
    if(patCount >= patSize) {
        patCount = 0;
        patPtr = pattern;
    }
}

//================================================
int main()
{
    DDRB = 0x1F;
    PRR = 0x03;
    getConfByte();
    setConfigByte();   // ݒ
    patCount = 0;
    patPtr = pattern;
    interruptCount = 32;
    startupTimer = 0;
    wdtEnable();

    while(1)
    {
        set_sleep_mode(SLEEP_MODE_PWR_DOWN);
        sleep_enable();
        sei();
        sleep_cpu();
        sleep_disable();

        //if((configByte == 0) && (startupTimer++ < (2000 / 16))) {
            // d̓[h́AN2bԂ͉Ȃ
        //} else {
            startupTimer = 9999;
            if(interruptCount-- == 0) {
                interruptCount = intervalCount;
                flashLED();
            }
        
            for(char r= 0; r < boostCount; r++)
            {
                PORTB = _BV(PB4);       // 
                PORTB = 0;
            }
        //}
    }
}

/*************************************************

            ݒɊւ鏈

 */

//================================================
void setConfigByte()
{
    boostCount = eeprom_read_byte(&confDefs[configByte].boostCount);
    dischargeClock = eeprom_read_byte(&confDefs[configByte].dischargeClock);
    intervalCount = eeprom_read_byte(&confDefs[configByte].intervalCount);
    patSize = eeprom_read_byte(&confDefs[configByte].pattarnLen);
    switch(eeprom_read_byte(&confDefs[configByte].pattarnNum)) {
    case 1:
        pattern = pattern1;
        break;
    case 2:
        pattern = pattern2;
        break;
    case 3:
        pattern = pattern3;
        break;
    case 5:
        pattern = patternF;
        break;
    default:
        pattern = pattern3;
        break;
    }    
}

//================================================
void getConfByte()
{
    DDRB = 0x1E;    // Set Input PB0
    PORTB = 0x01;   // Pullup enable
    configByte = eeprom_read_byte(&configSave);
    if(!(PINB & 0x01)) {
        configByte++;
        if(configByte >= NUM_PATTARN) configByte = 0;
        eeprom_busy_wait();
        eeprom_write_byte(&configSave, configByte);
        eeprom_busy_wait();
    }
    PORTB = 0;
    DDRB = 0x1F;
}
