/*

                GlM[En[xX^

			Copyrights 2010,  Yoshi Hiroshi

*/

#define ADXL245_POWER           PD6
#define ADXL245_SCL             PB3
#define ADXL245_SDA             PB0

#define ADXL245_ADDRESS_BASE     (0x53 << 1)

void adxl245Init();
void adxl245SendStartCondition();
void adxl245SendStopCondition();
unsigned char adxl245WriteData(unsigned char val);
unsigned char adxl245ReadData(unsigned char ack);
void adxl245Write(unsigned char reg, unsigned char* data, char len);
void adxl245Read(unsigned char reg, unsigned char* data, char len);

//--- Power control
#define ADXL245_POWER_ON            DDRD |= _BV(ADXL245_POWER);PORTD |= _BV(ADXL245_POWER)
#define ADXL245_POWER_OFF           DDRD &= ~_BV(ADXL245_POWER);PORTD &= ~_BV(ADXL245_POWER)

//--- SCL MACRO Assignment
#define ADXL245_SCL_AS_OUTPUT       DDRB |= _BV(ADXL245_SCL)
#define ADXL245_SCL_FREE			PORTB |= _BV(ADXL245_SCL)
#define ADXL245_SCL_SET_LOW		    ADXL245_SCL_AS_OUTPUT; PORTB &= ~_BV(ADXL245_SCL)
#define ADXL245_SCL_CURR_VAL		(PINB  & _BV(ADXL245_SCL))
//--- SDA MACRO Assignment
#define ADXL245_SDA_AS_INPUT		DDRB &= ~_BV(ADXL245_SDA)
#define ADXL245_SDA_AS_OUTPUT	    DDRB |= _BV(ADXL245_SDA)
#define ADXL245_SDA_FREE			ADXL245_SDA_AS_INPUT;PORTB |= _BV(ADXL245_SDA)
#define ADXL245_SDA_SET_LOW		    ADXL245_SDA_AS_OUTPUT; PORTB &= ~_BV(ADXL245_SDA)
#define ADXL245_SDA_CURR_VAL		(PINB  & _BV(ADXL245_SDA))


