/*

                GlM[En[xX^

			Copyrights 2010,  Yoshi Hiroshi

*/

#define IS_EEPROM_READY         (PORTD & _BV(EEPROM_POWER))

#define EEPROM_ADDRESS_BASE     (0x50 << 1)
#define EEPROM_BLOCK_SIZE       256
#define EEPROM_KBYTE_SIZE        (1024 * 1 / 8)

void eepromInit();
void eepromSendStartCondition();
void eepromSendStopCondition();
unsigned char eepromWriteData(unsigned char val);
void eepromWriteBlock(int block, unsigned char* data, int len);
char eepromIsBusy(int block);
unsigned char eepromReadData(unsigned char ack);
void eepromReadBlock(int block, unsigned char* data, int len);


// Device Dependent Configuration

//--- Bit Assignment
#define EEPROM_POWER            PD7
#define EEPROM_SCL              PB4
#define EEPROM_SDA              PB1

//--- Power control
#define EEPROM_POWER_ON         DDRD |= _BV(EEPROM_POWER);PORTD |= _BV(EEPROM_POWER)
#define EEPROM_POWER_OFF        DDRD &= ~_BV(EEPROM_POWER);PORTD &= ~_BV(EEPROM_POWER)

//--- SCL MACRO Assignment
#define EEPROM_SCL_AS_OUTPUT	DDRB |= _BV(EEPROM_SCL)
#define EEPROM_SCL_FREE			PORTB |= _BV(EEPROM_SCL)
#define EEPROM_SCL_SET_LOW		EEPROM_SCL_AS_OUTPUT; PORTB &= ~_BV(EEPROM_SCL)
#define EEPROM_SCL_CURR_VAL		(PINB  & _BV(EEPROM_SCL))
//--- SDA MACRO Assignment
#define EEPROM_SDA_AS_INPUT		DDRB &= ~_BV(EEPROM_SDA)
#define EEPROM_SDA_AS_OUTPUT	DDRB |= _BV(EEPROM_SDA)
#define EEPROM_SDA_FREE			EEPROM_SDA_AS_INPUT;PORTB |= _BV(EEPROM_SDA)
#define EEPROM_SDA_SET_LOW		EEPROM_SDA_AS_OUTPUT; PORTB &= ~_BV(EEPROM_SDA)
#define EEPROM_SDA_CURR_VAL		(PINB  & _BV(EEPROM_SDA))

