/*

                GlM[En[xX^

			Copyrights 2010,  Yoshi Hiroshi

*/

#define COMMUNICATION_CLOCK     0       // 8MHz
#define FAST_CLOCK              3       // 1MHz
#define MIDDLE_CLOCK            6       // 125KHz
#define SLOW_CLOCK              8       // 32KHz

#define CLOCK_COMMUNICATION     clockControl(COMMUNICATION_CLOCK)
#define CLOCK_FAST              clockControl(FAST_CLOCK)
#define CLOCK_MIDDLE            clockControl(MIDDLE_CLOCK)
#define CLOCK_SLOW              clockControl(SLOW_CLOCK)

#define SYSTEM_FLAG_TIMER_INT       0
#define SYSTEM_FLAG_UDRE_INT        1
#define SYSTEM_FLAG_REMOTE          5
#define SYSTEM_FLAG_GFATHER         6
#define SYSTEM_FLAG_POWER_INITED    7
#define IS_TIMER_INT            (GPIOR0 & _BV(SYSTEM_FLAG_TIMER_INT))
#define IS_UDRE_INT             (GPIOR0 & _BV(SYSTEM_FLAG_UDRE_INT))
#define IS_REMOTE               (GPIOR0 & _BV(SYSTEM_FLAG_REMOTE))
#define IS_GATHER               (GPIOR0 & _BV(SYSTEM_FLAG_GFATHER))
#define IS_POWER_INITED         (GPIOR0 & _BV(SYSTEM_FLAG_POWER_INITED))
#define SET_TIMER_INT            GPIOR0 |= _BV(SYSTEM_FLAG_TIMER_INT)
#define SET_UDRE_INT             GPIOR0 |= _BV(SYSTEM_FLAG_UDRE_INT)
#define SET_REMOTE               GPIOR0 |= _BV(SYSTEM_FLAG_REMOTE)
#define SET_GATHER               GPIOR0 |= _BV(SYSTEM_FLAG_GFATHER)
#define SET_POWER_INITED         GPIOR0 |= _BV(SYSTEM_FLAG_POWER_INITED)
#define CLEAR_TIMER_INT          GPIOR0 &= ~_BV(SYSTEM_FLAG_TIMER_INT)
#define CLEAR_UDRE_INT           GPIOR0 &= ~_BV(SYSTEM_FLAG_UDRE_INT)
#define CLEAR_REMOTE             GPIOR0 &= ~_BV(SYSTEM_FLAG_REMOTE)
#define CLEAR_GATHER             GPIOR0 &= ~_BV(SYSTEM_FLAG_GFATHER)
#define CLEAR_POWER_INITED       GPIOR0 &= ~_BV(SYSTEM_FLAG_POWER_INITED)

#define OPAMP1_PWR_ON           PORTD |= _BV(PD4)
#define OPAMP1_PWR_OFF          PORTD &= ~_BV(PD4)
#define OPAMP2_PWR_ON           PORTD |= _BV(PD5)
#define OPAMP2_PWR_OFF          PORTD &= ~_BV(PD5)


char clockControl(char speed);
void counterEnable(char speed);
void regMain(char limit);
void chargeCap();
char getGatherFlag();
void setGatherFlag(char f);

